SystemOrganization addCategory: #'Seaside-Cache-NG'!

WAObject subclass: #WACacheKeyEntryNG
	instanceVariableNames: 'key keyHash value next byAccessListEntry byCreationListEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WACacheKeyEntryNG class methodsFor: 'instance creation' stamp: 'pmm 9/10/2013 09:08'!
key: aKey value: anObject
	^ self basicNew
		initializeWithKey: aKey value: anObject;
		yourself! !

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:33'!
byAccessListEntry
	^ byAccessListEntry! !

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/10/2013 09:21'!
byAccessListEntry: aCacheListEntry
	byAccessListEntry := aCacheListEntry! !

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:33'!
byCreationListEntry
	^ byCreationListEntry! !

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/10/2013 09:22'!
byCreationListEntry: aCacheListEntry
	byCreationListEntry := aCacheListEntry! !

!WACacheKeyEntryNG methodsFor: 'initialization' stamp: 'pmm 9/10/2013 09:07'!
initializeWithKey: aKey value: anObject
	self initialize.
	key := aKey.
	keyHash := aKey hash.
	value := anObject! !

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:28'!
key
	^ key! !

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 11:51'!
keyHash
	^ keyHash! !

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 11:07'!
next
	^ next! !

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 14:53'!
next: aCacheKeyEntry
	next := aCacheKeyEntry! !

!WACacheKeyEntryNG methodsFor: 'printing' stamp: 'pmm 9/14/2013 16:29'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	key printOn: aStream.
	aStream nextPutAll: ' -> '.
	value printOn: aStream.
	aStream nextPut: $)! !

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:28'!
value
	^ value! !

!WACacheKeyEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 15:22'!
value: anObject
	value := anObject! !

WAObject subclass: #WACacheListEntryNG
	instanceVariableNames: 'previous next time cacheEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WACacheListEntryNG class methodsFor: 'instance creation' stamp: 'pmm 9/10/2013 09:16'!
entry: aCacheEntry
	^ self basicNew
		initializeWithEntry: aCacheEntry;
		yourself! !

!WACacheListEntryNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:27'!
cacheEntry
	^ cacheEntry! !

!WACacheListEntryNG methodsFor: 'operations' stamp: 'pmm 9/9/2013 12:06'!
expunge
	next isNil ifFalse: [
		next previous: previous ].
	previous isNil ifFalse: [
		previous next: next ].
	next := nil.
	previous := nil! !

!WACacheListEntryNG methodsFor: 'operations' stamp: 'pmm 9/9/2013 12:08'!
initializeTime
	time := Time totalSeconds! !

!WACacheListEntryNG methodsFor: 'initialization' stamp: 'pmm 9/10/2013 09:15'!
initializeWithEntry: aCacheEntry
	self initialize.
	cacheEntry := aCacheEntry.
	self initializeTime! !

!WACacheListEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 09:28'!
next
	^ next! !

!WACacheListEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 09:28'!
next: aCacheListEntry
	next := aCacheListEntry! !

!WACacheListEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 09:28'!
previous
	^ previous! !

!WACacheListEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 09:28'!
previous: aCacheListEntry
	previous := aCacheListEntry! !

!WACacheListEntryNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:17'!
time
	^ time! !

WAObject subclass: #WACacheNG
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WACacheNG commentStamp: 'pmm 9/9/2013 09:13' prior: 0!
WACacheNG is the abstract base class for session and continuation stores in Seaside. The default implementation is WAHashCacheNG.!

!WACacheNG methodsFor: 'accessing' stamp: 'pmm 8/26/2012 12:17'!
at: aKey ifAbsent: aBlock
	self subclassResponsibility! !

!WACacheNG methodsFor: 'putting' stamp: 'pmm 8/26/2012 12:15'!
at: aKey put: anObject
	self subclassResponsibility! !

!WACacheNG methodsFor: 'public' stamp: 'pmm 9/8/2013 17:50'!
clear
	self subclassResponsibility! !

!WACacheNG methodsFor: 'accessing' stamp: 'pmm 8/26/2012 12:19'!
keyAtValue: anObject ifAbsent: aBlock
	self subclassResponsibility! !

!WACacheNG methodsFor: 'accessing' stamp: 'pmm 9/10/2013 12:06'!
keySize
	^ 16! !

!WACacheNG methodsFor: 'enumerating' stamp: 'pmm 8/26/2012 12:04'!
keysAndValuesDo: aTwoArgumentBlock
	self subclassResponsibility! !

!WACacheNG methodsFor: 'removing' stamp: 'pmm 8/26/2012 12:16'!
remove: anObject
	self subclassResponsibility! !

!WACacheNG methodsFor: 'putting' stamp: 'pmm 8/26/2012 12:49'!
store: anObject
	"Store anObject in the cache, generating a new random key. Return the key."
	self subclassResponsibility! !

WACacheNG subclass: #WADictionaryCacheNG
	instanceVariableNames: 'byKey byValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WADictionaryCacheNG commentStamp: 'pmm 9/10/2013 11:35' prior: 0!
WADictionaryCacheNG is a dictionary based implementation of WACacheNG.!

!WADictionaryCacheNG methodsFor: 'accessing' stamp: 'pmm 9/10/2013 11:36'!
at: aKey ifAbsent: aBlock
	^ byKey at: aKey ifAbsent: aBlock! !

!WADictionaryCacheNG methodsFor: 'putting' stamp: 'pmm 9/14/2013 10:53'!
at: aKey put: anObject
	byValue at: anObject ifPresent: [ :key |
		key = aKey ifFalse: [
			self errorAlreadyMapped ] ].
	byKey at: aKey ifPresent: [ :value |
		byValue removeKey: value ].
	byKey at: aKey put: anObject.
	byValue at: anObject put: aKey.
	^ anObject! !

!WADictionaryCacheNG methodsFor: 'public' stamp: 'pmm 9/10/2013 11:39'!
clear
	byKey removeAll.
	byValue removeAll! !

!WADictionaryCacheNG methodsFor: 'private' stamp: 'pmm 2/1/2014 12:21'!
errorAlreadyMapped
	self error: 'Already mapped'! !

!WADictionaryCacheNG methodsFor: 'private' stamp: 'pmm 1/31/2014 15:56'!
includesKey: key
	^ byKey includesKey: key! !

!WADictionaryCacheNG methodsFor: 'initialization' stamp: 'pmm 9/14/2013 10:41'!
initialize
	super initialize.
	byKey := Dictionary new.
	byValue := Dictionary new! !

!WADictionaryCacheNG methodsFor: 'accessing' stamp: 'pmm 9/10/2013 11:37'!
keyAtValue: anObject ifAbsent: aBlock
	^ byValue at: anObject ifAbsent: aBlock! !

!WADictionaryCacheNG methodsFor: 'enumerating' stamp: 'pmm 9/10/2013 11:38'!
keysAndValuesDo: aTwoArgumentBlock
	byKey keysAndValuesDo: aTwoArgumentBlock! !

!WADictionaryCacheNG methodsFor: 'copying' stamp: 'pmm 9/14/2013 16:26'!
postCopy
	super postCopy.
	byKey := byKey copy.
	byValue := byValue copy! !

!WADictionaryCacheNG methodsFor: 'removing' stamp: 'pmm 9/10/2013 11:42'!
remove: anObject
	| key |
	key := byValue removeKey: anObject.
	byKey removeKey: key! !

!WADictionaryCacheNG methodsFor: 'putting' stamp: 'pmm 9/10/2013 11:41'!
store: anObject
	| candidateKey |
	[ 
		candidateKey := WAKeyGenerator current keyOfLength: self keySize.
		self includesKey: candidateKey ] whileTrue.
	self at: candidateKey put: anObject.
	^ candidateKey! !

WACacheNG subclass: #WAHashCacheNG
	instanceVariableNames: 'keyTable valueTable size maximumSize maximumRelativeAge maximumAbsoluteAge overflowAction byAccessStart byAccessEnd byCreationStart byCreationEnd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WAHashCacheNG commentStamp: 'pmm 8/19/2014 09:46' prior: 0!
WAHashCacheNG is a hash table based implementation of WACacheNG.

The characteristics of WAHashCacheNG are:
- supports both absolute and relative timeouts at the same time https://www.owasp.org/index.php/Session_Management_Cheat_Sheet#Automatic_Session_Expiration
- supports a maximum size with definable overflow action (expire oldest, expire least recently used, signal exception)
- access by key is fast (O(1) average case O(n) worst case)
- access by value is fast (O(1) average case O(n) worst case)
- reaping expired sessions is proportional (O(n)) to the number of expired session and independent of the total number of sessions (O(1))
- creating a new session independent of the total number of sessions
- does not guard against hash collision attacks, you should not use user generated keys

Instance Variables:
	keyTable 				<Array>
	valueTable				<Array>
	size					<Integer>
	maximumSize			<Integer>
	maximumRelativeAge	<Integer>
	maximumAbsoluteAge	<Integer>
	overflowAction			<Symbol>
	byAccessStart			<WACacheListEntryNG>
	byAccessEnd			<WACacheListEntryNG>
	byCreationStart		<WACacheListEntryNG>
	byCreationEnd			<WACacheListEntryNG>!

!WAHashCacheNG class methodsFor: 'instance creation' stamp: 'pmm 9/10/2013 11:34'!
initialSize: anSizeInteger maximumSize: aMaximumSizeInteger maximumAbsoluteAge: aMaximumAbsoluteAge maximumRelativeAge: aMaximumRelativeAge overflowAction: aOverflowActionSymbol
	^ self basicNew
		initializeWithInitialSize: anSizeInteger maximumSize: aMaximumSizeInteger maximumAbsoluteAge: aMaximumAbsoluteAge maximumRelativeAge: aMaximumRelativeAge overflowAction: aOverflowActionSymbol;
		yourself! !

!WAHashCacheNG class methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:16'!
overflowActions
	^ Array
		with: self removeRelativeOldest
		with: self removeAbsoluteOldest
		with: self signalError! !

!WAHashCacheNG class methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:15'!
removeAbsoluteOldest
	^ #removeAbsoluteOldest! !

!WAHashCacheNG class methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:15'!
removeRelativeOldest
	^ #removeRelativeOldest! !

!WAHashCacheNG class methodsFor: 'accessing' stamp: 'pmm 9/8/2013 18:01'!
signalError
	^ #signalError! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/10/2013 17:22'!
addToAccessEnd: aCacheListEntry
	| currentLast |
	currentLast := byAccessEnd.
	currentLast isNil ifFalse: [
		currentLast next: aCacheListEntry.
		aCacheListEntry previous: currentLast ].
	aCacheListEntry initializeTime.
	byAccessEnd := aCacheListEntry.
	byAccessStart isNil ifTrue: [
		byAccessStart := aCacheListEntry ]! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/10/2013 17:23'!
addToCreationEnd: aCacheListEntry
	| currentLast |
	currentLast := byCreationEnd.
	currentLast isNil ifFalse: [
		currentLast next: aCacheListEntry.
		aCacheListEntry previous: currentLast ].
	byCreationEnd := aCacheListEntry.
	byCreationStart isNil ifTrue: [
		byCreationStart := aCacheListEntry ]! !

!WAHashCacheNG methodsFor: 'accessing' stamp: 'pmm 9/10/2013 12:33'!
at: aKey ifAbsent: aBlock
	| keyHash index entry |
	self sweepIncrementally.
	keyHash := aKey hash.
	index := (keyHash \\ keyTable size) + 1.
	entry := self findEntryOrNilWithKey: aKey hash: keyHash index: index.
	^ entry isNil
		ifTrue: [ aBlock value ]
		ifFalse: [ entry value ]! !

!WAHashCacheNG methodsFor: 'putting' stamp: 'pmm 2/1/2014 10:55'!
at: aKey put: anObject
	self at: aKey put: anObject overwrite: true.
		
	^ anObject! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 2/1/2014 10:55'!
at: aKey put: anObject overwrite: aBoolean
	| index keyHash entry |
	self sweepIncrementally.
	self growCheck.
	keyHash := aKey hash.
	index := (keyHash \\ keyTable size) + 1.
	entry := self findEntryOrNilWithKey: aKey hash: keyHash index: index.
	entry isNil
		ifTrue: [
			"no mapping for this key exists"
			| cacheEntry byAccessEntry byCreationEntry |
			(maximumSize > 0 and: [ size = maximumSize ])
				ifTrue: [ self performOverflowAction ].
			"create entry"
			cacheEntry := WACacheKeyEntryNG key: aKey value: anObject.
			byCreationEntry := WACacheListEntryNG entry: cacheEntry.
			byAccessEntry := WACacheListEntryNG entry: cacheEntry.
			cacheEntry byAccessListEntry: byAccessEntry.
			cacheEntry byCreationListEntry: byCreationEntry.
			self addToAccessEnd: byAccessEntry.
			self addToCreationEnd: byCreationEntry.
			self insertKeyEntry: cacheEntry.
			"update value table"
			self mapValue: anObject to: aKey expectMapping: false.
			size := size + 1 ]
		ifFalse: [
			"a mapping for this key already exists"
			| byAccessListEntry byCreationListEntry |
			aBoolean ifFalse: [ ^ false ].
			
			byAccessListEntry := entry byAccessListEntry.
			byCreationListEntry := entry byCreationListEntry.
			self expunge: byAccessListEntry.
			self addToAccessEnd: byAccessListEntry.
			self expunge: byCreationListEntry.
			self addToCreationEnd: byCreationListEntry.
			self updateMappingOf: aKey from: entry value to: anObject.
			
			"update entry"
			entry value: anObject ].
		
	^ true! !

!WAHashCacheNG methodsFor: 'public' stamp: 'pmm 8/16/2014 16:52'!
clear
	size := 0.
	keyTable atAllPut: nil.
	valueTable atAllPut: nil. 
	byAccessStart := nil.
	byAccessEnd := nil.
	byCreationStart := nil.
	byCreationEnd := nil! !

!WAHashCacheNG methodsFor: 'copying' stamp: 'pmm 9/11/2013 10:42'!
copy
	| copy |
	copy := self class initialSize: keyTable size maximumSize: maximumSize maximumAbsoluteAge: maximumAbsoluteAge maximumRelativeAge: maximumRelativeAge overflowAction: overflowAction.
	self keysAndValuesDo: [ :key :value |
		copy at: key put: value ].
	^ copy! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 2/1/2014 12:21'!
errorAlreadyMapped
	self error: 'Already mapped'! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/9/2013 15:14'!
errorKeyNotFound
	self error: 'Key not found'! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/10/2013 11:53'!
errorNotMapped
	self error: 'Not mapped'! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/14/2013 16:30'!
expunge: aListEntry
	"update list start"
	aListEntry == byAccessStart
		ifTrue: [ byAccessStart := aListEntry next ].
	aListEntry == byCreationStart
		ifTrue: [ byCreationStart := aListEntry next ].
	"update list end"
	aListEntry == byAccessEnd
		ifTrue: [ byAccessEnd := aListEntry previous ].
	aListEntry == byCreationEnd
		ifTrue: [ byCreationEnd := aListEntry previous ].
	"fix previous and next pointers"
	aListEntry expunge! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/10/2013 12:20'!
findEntryOrNilWithKey: aKey hash: anHashInteger index: anIndexInteger
	| entry |
	entry := keyTable at: anIndexInteger.
	[ entry isNil ] whileFalse: [
		(entry keyHash = anHashInteger and: [ entry key = aKey ])
			ifTrue: [
				| byAccessListEntry |
				byAccessListEntry := entry byAccessListEntry.
				self expunge: byAccessListEntry.
				self addToAccessEnd: byAccessListEntry.
				^ entry ]
			ifFalse: [ entry := entry next ] ].
	^ nil! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 8/19/2014 10:19'!
growCheck
	size > (keyTable size * self loadFactor) ifTrue: [
		"rehash for fun"
		| newKeyTable newValueTable newTableSize |
		newTableSize := WAHashTableSizes atLeast: keyTable size * 2.
		newKeyTable := Array new: newTableSize.
		newValueTable := Array new: newTableSize.
		
		"rehash keys"
		keyTable do: [ :each |
			| next current |
			current := each.
			[ current isNil ] whileFalse: [
				| index atTargetIndex |
				next := current next.
				index := (current keyHash \\ newTableSize) + 1.
				atTargetIndex := newKeyTable at: index.
				atTargetIndex isNil
					ifTrue: [ newKeyTable at: index put: current ]
					ifFalse: [
						[ atTargetIndex next isNil ] whileFalse: [
							atTargetIndex := atTargetIndex next ].
						atTargetIndex next: current ].
				current next: nil.
				current := next ] ].
		
		"rehash values"
		valueTable do: [ :each |
			| next current |
			current := each.
			[ current isNil ] whileFalse: [
				| index atTargetIndex |
				next := current next.
				index := (current valueHash \\ newTableSize) + 1.
				atTargetIndex := newValueTable at: index.
				atTargetIndex isNil
					ifTrue: [ newValueTable at: index put: current ]
					ifFalse: [
						[ atTargetIndex next isNil ] whileFalse: [
							atTargetIndex := atTargetIndex next ].
						atTargetIndex next: current ].
				current next: nil.
				current := next ] ].
		keyTable := newKeyTable.
		valueTable := newValueTable ]! !

!WAHashCacheNG methodsFor: 'initialization' stamp: 'pmm 9/10/2013 17:20'!
initializeWithInitialSize: anSizeInteger maximumSize: aMaximumSizeInteger maximumAbsoluteAge: aMaximumAbsoluteAge maximumRelativeAge: aMaximumRelativeAge overflowAction: aOverflowActionSymbol
	self initialize.
	size := 0.
	keyTable := Array new: anSizeInteger.
	valueTable := Array new: anSizeInteger.
	maximumSize := aMaximumSizeInteger.
	maximumAbsoluteAge := aMaximumAbsoluteAge.
	maximumRelativeAge := aMaximumRelativeAge.
	overflowAction := aOverflowActionSymbol! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/10/2013 12:58'!
insertKeyEntry: aCacheEntry
	| keyHash key index entry previous |
	keyHash := aCacheEntry keyHash.
	key := aCacheEntry key.
	index := (keyHash \\ valueTable size) + 1.
	entry := keyTable at: index.
	previous := nil.
	[ entry isNil ] whileFalse: [
		(entry keyHash = aCacheEntry and: [ entry key = key ])
			ifTrue: [
				previous isNil
					ifTrue: [ keyTable at: index put: aCacheEntry ]
					ifFalse: [  previous next: aCacheEntry ].
				^ self ]
			ifFalse: [
				previous := entry.
				entry := entry next ] ].
	previous isNil
		ifTrue: [ keyTable at: index put: aCacheEntry ]
		ifFalse: [  previous next: aCacheEntry ]! !

!WAHashCacheNG methodsFor: 'accessing' stamp: 'pmm 9/10/2013 12:39'!
keyAtValue: anObject ifAbsent: aBlock
	| valueHash index entry |
	self sweepIncrementally.
	valueHash := anObject hash.
	index := (valueHash \\ valueTable size) + 1.
	entry := valueTable at: index.
	[ entry isNil ] whileFalse: [
		(entry valueHash = valueHash and: [ entry value = anObject ])
			ifTrue: [
				"update access time"
				self at: entry key ifAbsent: [ self errorKeyNotFound ].
				^ entry key ]
			ifFalse: [ entry := entry next ] ].
	^ aBlock value! !

!WAHashCacheNG methodsFor: 'enumerating' stamp: 'pmm 9/10/2013 12:21'!
keysAndValuesDo: aTwoArgumentBlock
	self sweepIncrementally.
	keyTable do: [ :each |
		| cacheEntry |
		cacheEntry := each.
		[ cacheEntry isNil ] whileFalse: [
			aTwoArgumentBlock value: cacheEntry key value: cacheEntry value.
			cacheEntry := cacheEntry next ] ]! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/9/2013 09:17'!
loadFactor
	^ 0.75! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/10/2013 12:35'!
mapValue: anObject to: aKey expectMapping: aBoolean
	| valueHash index entry previous newEntry |
	valueHash := anObject hash.
	index := (valueHash \\ valueTable size) + 1.
	newEntry := WACacheValueEntryNG value: anObject key: aKey.
	entry := valueTable at: index.
	previous := nil.
	[ entry isNil ] whileFalse: [
		(entry valueHash = valueHash and: [ entry value = anObject ])
			ifTrue: [
				aBoolean ifFalse: [ self errorAlreadyMapped ].
				previous isNil
					ifTrue: [ valueTable at: index put: newEntry ]
					ifFalse: [  previous next: newEntry ].
				^ self ]
			ifFalse: [
				previous := entry.
				entry := entry next ] ].
	
	aBoolean ifTrue: [ self errorNotMapped ].
	previous isNil
			ifTrue: [ valueTable at: index put: newEntry ]
			ifFalse: [  previous next: newEntry ]! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/9/2013 12:01'!
performOverflowAction
	overflowAction == self class signalError ifTrue: [
		WAMaximumNumberOfSessionsExceededError signal ].
	overflowAction == self class removeAbsoluteOldest ifTrue: [
		self removeCacheEntry: byCreationStart cacheEntry ].
	overflowAction == self class removeRelativeOldest ifTrue: [
		self removeCacheEntry: byAccessStart cacheEntry ]! !

!WAHashCacheNG methodsFor: 'removing' stamp: 'pmm 9/9/2013 11:14'!
remove: anObject
	| key |
	self sweepIncrementally.
	key := self keyAtValue: anObject ifAbsent: [ ^ anObject ].
	self removeKey: key! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/9/2013 14:46'!
removeCacheEntry: aCacheEntry
	self removeFromKeyTable: aCacheEntry.
	self removeFromValueTable: aCacheEntry value.
	self expunge: aCacheEntry byAccessListEntry.
	self expunge: aCacheEntry byCreationListEntry.
	
	size := size - 1! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/10/2013 12:56'!
removeFromKeyTable: aCacheEntry
	| index entry previous |
	index := (aCacheEntry keyHash \\ keyTable size) + 1.
	entry := keyTable at: index.
	previous := nil.
	"no need for nil check, it has to be here"
	[ aCacheEntry == entry ] whileFalse: [
		previous := entry.
		entry := entry next ].
	previous isNil
		ifTrue: [ keyTable at: index put: entry next ]
		ifFalse: [ previous next: entry next ]! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/14/2013 16:30'!
removeFromValueTable: anObject
	| entry valueHash index previous |
	valueHash := anObject hash.
	index := (valueHash \\ valueTable size) + 1.
	entry := valueTable at: index.
	previous := nil.
	[	"no need for nil check it has to be there"
		(entry valueHash = valueHash and: [ entry value = anObject ])
			ifTrue: [
				 previous isNil
					ifTrue: [ valueTable at: index put: entry next ]
					ifFalse: [ previous next: entry next ].
				^ self ]
			ifFalse: [
				previous := entry.
				entry := entry next ] ] repeat! !

!WAHashCacheNG methodsFor: 'removing' stamp: 'pmm 9/10/2013 12:35'!
removeKey: aKey
	| keyHash index entry |
	self sweepIncrementally.
	keyHash := aKey hash.
	index := (keyHash \\ keyTable size) + 1.
	entry := self findEntryOrNilWithKey: aKey hash: keyHash index: index.
	^ entry isNil
		ifTrue: [ self errorKeyNotFound ]
		ifFalse: [ self removeCacheEntry: entry ]! !

!WAHashCacheNG methodsFor: 'putting' stamp: 'pmm 2/1/2014 10:56'!
store: anObject
	| candidateKey |
	[ 
		candidateKey := WAKeyGenerator current keyOfLength: self keySize.
		self at: candidateKey put: anObject overwrite: false ] whileFalse.
	^ candidateKey! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/11/2013 09:41'!
sweep: aListRoot maximumAge: anNumberOfSeconds now: currentSeconds
	| current |
	current := aListRoot.
	[ current isNil ] whileFalse: [
		(currentSeconds - current time) > anNumberOfSeconds
			ifTrue: [
				self removeCacheEntry: current cacheEntry.
				current := current next ]
			ifFalse: [
				"the list is ordered so we can stop scanning"
				^ self ] ]! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/9/2013 12:01'!
sweepIncrementally
	| now |
	now := Time totalSeconds.
	
	"absolute timeout sweep"
	maximumAbsoluteAge > 0 ifTrue: [
		self sweep: byCreationStart maximumAge: maximumAbsoluteAge now: now ].
	
	"relative timeout sweep"
	maximumRelativeAge > 0 ifTrue: [
		self sweep: byAccessStart maximumAge: maximumRelativeAge now: now ]! !

!WAHashCacheNG methodsFor: 'private' stamp: 'pmm 9/10/2013 12:46'!
updateMappingOf: aKey from: oldValue to: newValue
	self removeFromValueTable: oldValue.
	self mapValue: newValue to: aKey expectMapping: false! !

WACacheNG subclass: #WAMutualExclusionCacheNG
	instanceVariableNames: 'mutex cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WAMutualExclusionCacheNG commentStamp: 'pmm 9/9/2013 09:07' prior: 0!
WAMutualExclusionCacheNG is a wrapper around a WACacheNG that wraps all messages in a mutex.

Instance Variables:
	mutex	<WAMutex>
	cache	<WACache>!

!WAMutualExclusionCacheNG class methodsFor: 'instance creation' stamp: 'pmm 8/26/2012 12:08'!
on: aCache
	^ self basicNew initializeOn: aCache; yourself! !

!WAMutualExclusionCacheNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 17:48'!
at: aKey ifAbsent: aBlock
	^ mutex critical: [
		cache at: aKey ifAbsent: aBlock ]	! !

!WAMutualExclusionCacheNG methodsFor: 'putting' stamp: 'pmm 9/8/2013 17:49'!
at: aKey put: anObject
	^ mutex critical: [
		cache at: aKey put: anObject ]	! !

!WAMutualExclusionCacheNG methodsFor: 'public' stamp: 'pmm 9/8/2013 17:49'!
clear
	^ mutex critical: [
		cache clear ]	! !

!WAMutualExclusionCacheNG methodsFor: 'initialization' stamp: 'pmm 9/1/2012 11:07'!
initializeOn: aCache
	self initialize.
	mutex := WAMutex new.
	cache := aCache! !

!WAMutualExclusionCacheNG methodsFor: 'accessing' stamp: 'pmm 9/8/2013 17:48'!
keyAtValue: anObject ifAbsent: aBlock
	^ mutex critical: [
		cache keyAtValue: anObject ifAbsent: aBlock ]	! !

!WAMutualExclusionCacheNG methodsFor: 'accessing' stamp: 'pmm 9/10/2013 12:07'!
keySize
	^ mutex critical: [
		cache keySize ]	! !

!WAMutualExclusionCacheNG methodsFor: 'enumerating' stamp: 'pmm 9/8/2013 17:48'!
keysAndValuesDo: aTwoArgumentBlock
	^ mutex critical: [
		cache keysAndValuesDo: aTwoArgumentBlock ]	! !

!WAMutualExclusionCacheNG methodsFor: 'copying' stamp: 'pmm 9/14/2013 16:26'!
postCopy
	super postCopy.
	mutex := WAMutex new.
	cache := cache copy! !

!WAMutualExclusionCacheNG methodsFor: 'removing' stamp: 'pmm 9/8/2013 17:50'!
remove: anObject
	^ mutex critical: [
		cache remove: anObject ]	! !

!WAMutualExclusionCacheNG methodsFor: 'putting' stamp: 'pmm 8/26/2012 12:48'!
store: anObject
	^ mutex critical: [
		cache store: anObject ]	! !

WAObject subclass: #WACacheValueEntryNG
	instanceVariableNames: 'value valueHash key next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WACacheValueEntryNG class methodsFor: 'instance creation' stamp: 'pmm 9/10/2013 09:12'!
value: anObject key: aKey
	^ self basicNew
		initializeWithValue: anObject key: aKey
		yourself! !

!WACacheValueEntryNG methodsFor: 'initialization' stamp: 'pmm 9/10/2013 09:12'!
initializeWithValue: anObject key: aKey
	self initialize.
	value := anObject.
	valueHash := anObject hash.
	key := aKey! !

!WACacheValueEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 13:26'!
key
	^ key! !

!WACacheValueEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 13:26'!
next
	^ next! !

!WACacheValueEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 15:08'!
next: aCacheValueEntry
	next := aCacheValueEntry! !

!WACacheValueEntryNG methodsFor: 'printing' stamp: 'pmm 9/14/2013 16:29'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	value printOn: aStream.
	aStream nextPutAll: ' <- '.
	key printOn: aStream.
	aStream nextPut: $)! !

!WACacheValueEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 13:27'!
value
	^ value! !

!WACacheValueEntryNG methodsFor: 'accessing' stamp: 'pmm 9/9/2013 13:26'!
valueHash
	^ valueHash! !

WAObject subclass: #WAHashTableSizes
	instanceVariableNames: 'candidate goodPrimes primesToAvoid valuesNotToDivide'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

WAHashTableSizes class
	instanceVariableNames: 'sizes'!

!WAHashTableSizes commentStamp: 'pmm 2/1/2014 12:19' prior: 0!
WAHashTableSizes is a helper class, used by hashedCollections to determine sizes for hash tables.

Public protocol is all class-side:

#goodSizeAtLeast: anInteger 
  answers a "good" integer greater than or equal to the given integer.

An integer is not "good" as a hash table size if it is any of:
* Not prime
* Divides 256**k +- a, for small k and a
* Close to a power of two
* Close to dividing the hashMultiply constant

See Andres Valloud's hashing book, and Knuth TAOCP vol. 3.

This class caches a table of selected good primes within the positive SmallInteger range. When this table must be rebuilt, it uses an instance to compute the table. Primes are selected to keep the table fairly small, with approximately five entries per power of two.

The cached table is ordered, and is searched with a binary search to find the closest good size >= the requested size.

Original implementation by Martin McClure!

WAHashTableSizes class
	instanceVariableNames: 'sizes'!

!WAHashTableSizes class methodsFor: 'public' stamp: 'pmm 9/10/2013 15:46'!
atLeast: lowerLimit
	"Answer the next good size >= lowerlimit.
	If lowerLimit is larger than the largest known good prime,
	just make it odd."

	| primes low mid high prime |
	primes := self sizes.
	low := 1.
	high := primes size.
	lowerLimit > (primes at: high)
		ifTrue: [
			^ lowerLimit even
				ifTrue: [ lowerLimit + 1 ]
				ifFalse: [ lowerLimit ] ].
	[ mid := (high - low) // 2 + low.
	prime := primes at: mid.
	prime < lowerLimit
		ifTrue: [ low := mid ]
		ifFalse: [ high := mid ].
	high - low <= 1
		ifTrue: [ ^ primes at: high ] ] repeat! !

!WAHashTableSizes class methodsFor: 'initialize-release' stamp: 'MartinMcClure 1/17/2010 09:51'!
initialize
	"Throw away any previously-cached sizes, then compute and cache the sizes."
	"WAHashTableSizes initialize"
	
	sizes := nil.
	self sizes! !

!WAHashTableSizes class methodsFor: 'private' stamp: 'pmm 9/10/2013 15:46'!
numValuesPerPower
	"Answer the number of values that should be available in the cached table of primes
	for each power-of-two range. A larger number allows closer sizing for pre-sized collections,
	but results in a larger table that takes longer to search."
	
	^ 5 "Chosen so there will be fewer than 128 primes in the sizes table"! !

!WAHashTableSizes class methodsFor: 'private' stamp: 'pmm 8/16/2014 16:33'!
sizes
	sizes isNil
		ifTrue: [ sizes := self new computeSizes ].
	^ sizes! !

!WAHashTableSizes methodsFor: 'private' stamp: 'MartinMcClure 1/17/2010 09:43'!
candidateIsGoodPrime
	"Answer true if candidate will make a good hash table size.
	Some integers are rejected:
	* Non-primes
	* Primes which are close to dividing 1664525, the hashMultiply constant
	* Primes which divide 256**k +- a, for small k and a
	See Andres Valloud's hashing book, and Knuth TAOCP volume 3."

	candidate isPrime
		ifFalse: [ ^ false ].
	(primesToAvoid includes: candidate)
		ifTrue: [ ^ false ].
	candidate < 256
		ifTrue: [ ^ true ].	"Small primes cannot satisify divisibility constraints"
	^ valuesNotToDivide allSatisfy: [ :dividend | dividend \\ candidate ~~ 0 ]! !

!WAHashTableSizes methodsFor: 'private' stamp: 'pmm 9/10/2013 15:47'!
computeSizes
	"Answer an array of integers that make good hash table sizes.
	In each power of two, there are about five primes to choose from.
	Some primes are rejected:
	* Primes close to a power of two.
	* Primes which divide 256**k +- a, for small k and a
	* Primes which are close to dividing 1664525, the hashMultiply constant
	See Andres Valloud's hashing book, and Knuth TAOCP volume 3."

	| logInterval |
	logInterval := 0.5 / self numValuesPerPower.
	2 + logInterval to: 30 by: 2 * logInterval do: [ :exp | 
		(self goodPrimeForExp: exp)
			ifNotNil: [ :prime | 
				goodPrimes last ~~ prime
					ifTrue: [ goodPrimes add: prime ] ] ].
	^ goodPrimes asArray! !

!WAHashTableSizes methodsFor: 'private' stamp: 'pmm 9/10/2013 15:47'!
firstCandidateForExp: exp
	"Answer the smallest odd integer greater 2**exp."
	
	| n |
	n := (2 raisedTo: exp) rounded.
	^ n odd 
		ifTrue: [ n ]
		ifFalse: [ n + 1 ]! !

!WAHashTableSizes methodsFor: 'private' stamp: 'pmm 9/14/2013 16:53'!
goodPrimeForExp: exp
	"Answer the next prime integer >= 2**exp that will make a good hash table size,
	Some primes are rejected:
	* Primes close to a power of two.
	* Primes which divide 256**k +- a, for small k and a
	* Primes which are close to dividing 1664525, the hashMultiply constant
	See Andres Valloud's hashing book, and Knuth TAOCP volume 3."

	| limit |
	candidate := self firstCandidateForExp: exp.
	limit := self limitForExp: exp.
	[ self candidateIsGoodPrime ]
		whileFalse:
			[ candidate := candidate + 2.
			candidate > limit
				ifTrue: [ ^ nil ] ].
	^ candidate! !

!WAHashTableSizes methodsFor: 'initialization' stamp: 'pmm 8/16/2014 16:58'!
initialize
	"Can't use any hashed collections, if sizes is being initialized might get infinite recursion"
	super initialize.
	goodPrimes := OrderedCollection new.	
	"Must contain a value less than any prime to avoid extra work in binary search"
	goodPrimes add: 0.
	valuesNotToDivide := OrderedCollection new.
	1 to: 8 do: [ :k | 
		| n |
		n := 256 raisedToInteger: k.
		-32 to: 32 do: [ :a | valuesNotToDivide add: n + a ] ].
	primesToAvoid := self primeAlmostFactorsOf: 1 hashMultiply! !

!WAHashTableSizes methodsFor: 'private' stamp: 'pmm 9/14/2013 16:30'!
limitForExp: exp
	"Answer the largest integer that isn't too close to the next higher power of 2 than exp."
	
	| expLimit |
	expLimit := exp ceiling - (0.5 / self numValuesPerPower).
	^ (2 raisedTo: expLimit) rounded
	! !

!WAHashTableSizes methodsFor: 'private' stamp: 'pmm 9/10/2013 15:48'!
numValuesPerPower
	"Answer the number of values that should be available in the cached table of primes
	for each power-of-two range."
	
	^ self class numValuesPerPower
! !

!WAHashTableSizes methodsFor: 'private' stamp: 'pmm 2/1/2014 12:23'!
primeAlmostFactorsOf: anInteger
	"Answer primes less than anInteger whose remainder when dividing anInteger is small"

	| factors |
	factors := OrderedCollection new.
	anInteger even ifTrue: [
		factors add: 2 ].
	3 to: anInteger // 2 + 2 by: 2 do: [ :i | 
		(i isPrime and: [
			| remainder | 
			remainder := anInteger \\ i.
			remainder <= 1 or: [ remainder = (i - 1) ] ])
				ifTrue: [ factors add: i ] ].
	^ factors asArray	
! !

WAError subclass: #WAMaximumNumberOfSessionsExceededError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WAMaximumNumberOfSessionsExceededError commentStamp: 'pmm 9/8/2013 17:59' prior: 0!
http://ora-00018.ora-code.com/!

WAAttributeEditor subclass: #WACacheNGAttributeEditor
	instanceVariableNames: 'handler maximumSize maximumAbsoluteAge maximumRelativeAge overflowAction overflowActionLabels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WACacheNGAttributeEditor methodsFor: 'private' stamp: 'pmm 2/1/2014 14:27'!
createCache
	^ WAMutualExclusionCacheNG on: (WAHashCacheNG
		initialSize: 13
		maximumSize: maximumSize
		maximumAbsoluteAge: maximumAbsoluteAge
		maximumRelativeAge: maximumRelativeAge
		overflowAction: overflowAction)! !

!WACacheNGAttributeEditor methodsFor: 'accessing' stamp: 'pmm 2/1/2014 14:22'!
handler
	^ handler! !

!WACacheNGAttributeEditor methodsFor: 'accessing' stamp: 'pmm 2/2/2014 19:09'!
handler: anApplication
	handler := anApplication.
	maximumSize := anApplication configuration at: #maximumSize.
	maximumRelativeAge := anApplication configuration at: #maximumRelativeAge.
	maximumAbsoluteAge := anApplication configuration at: #maximumAbsoluteAge.
	overflowAction := anApplication configuration at: #overflowAction! !

!WACacheNGAttributeEditor methodsFor: 'initialization' stamp: 'pmm 8/16/2014 16:44'!
initialize
	super initialize.
	overflowActionLabels := Dictionary new.
	overflowActionLabels at: WAHashCacheNG removeAbsoluteOldest put: 'remove the oldest element'.
	overflowActionLabels at: WAHashCacheNG removeRelativeOldest put: 'remove the element last accessed the longest time ago'.
	overflowActionLabels at: WAHashCacheNG signalError put: 'signal an error'! !

!WACacheNGAttributeEditor methodsFor: 'accessing' stamp: 'pmm 2/1/2014 14:49'!
maximumAbsoluteAge
	^ maximumAbsoluteAge! !

!WACacheNGAttributeEditor methodsFor: 'accessing' stamp: 'pmm 2/1/2014 14:49'!
maximumAbsoluteAge: anInteger
	maximumAbsoluteAge := anInteger
! !

!WACacheNGAttributeEditor methodsFor: 'accessing' stamp: 'pmm 2/1/2014 14:50'!
maximumRelativeAge
	^ maximumRelativeAge! !

!WACacheNGAttributeEditor methodsFor: 'accessing' stamp: 'pmm 2/1/2014 14:50'!
maximumRelativeAge: anInteger
	maximumRelativeAge := anInteger
! !

!WACacheNGAttributeEditor methodsFor: 'accessing' stamp: 'pmm 2/1/2014 14:47'!
maximumSize
	^ maximumSize! !

!WACacheNGAttributeEditor methodsFor: 'accessing' stamp: 'pmm 2/1/2014 14:47'!
maximumSize: anInteger
	maximumSize := anInteger
! !

!WACacheNGAttributeEditor methodsFor: 'accessing' stamp: 'pmm 2/1/2014 14:50'!
overflowAction
	^ overflowAction! !

!WACacheNGAttributeEditor methodsFor: 'accessing' stamp: 'pmm 2/1/2014 14:50'!
overflowAction: aSymbol
	overflowAction := aSymbol
! !

!WACacheNGAttributeEditor methodsFor: 'rendering' stamp: 'pmm 2/1/2014 14:40'!
renderCacheReplaceOn: html
	html paragraph: [
		html button
			class: 'large';
			title: 'Replace the cache';
			callback: [ self replaceCache ];
			with: 'Replace cache' ]! !

!WACacheNGAttributeEditor methodsFor: 'rendering' stamp: 'pmm 2/1/2014 15:49'!
renderConfigurationOn: html
	html form: [
		html table
			cellspacing: 0;
			cellpadding: 0;
			with: [
				self renderMaximumAbsoluteAgeOn: html.
				self renderMaximumRelativeAgeOn: html.
				self renderMaximumSizeOn: html.
				self renderOverflowActionOn: html ].
			
		self renderCacheReplaceOn: html ]! !

!WACacheNGAttributeEditor methodsFor: 'rendering' stamp: 'pmm 2/1/2014 16:06'!
renderMaximumAbsoluteAgeOn: html
	html tableRow: [
		html tableHeading: [
			html label: 'Maximum Absolute Age' ].
		html tableData: [ 
			html textInput
			size: 5;
			on: #maximumAbsoluteAge of: self ]  ].
	html tableRow: [
		html tableData
			colSpan: 2;
			with: 'After so many seconds after its creation a session is considered expired no matter when it was last accessed. 0 for no limit. Has to be positive.' ]! !

!WACacheNGAttributeEditor methodsFor: 'rendering' stamp: 'pmm 2/1/2014 16:07'!
renderMaximumRelativeAgeOn: html
	html tableRow: [
		html tableHeading: [
			html label: 'Maximum Relative Age' ].
		html tableData: [ 
			html textInput
			size: 5;
			on: #maximumRelativeAge of: self ] ].
	
	html tableRow: [
		html tableData
			colSpan: 2;
			with: 'After so many seconds of inactivity a session is considered expired. 0 for no limit. Has to be positive.' ]! !

!WACacheNGAttributeEditor methodsFor: 'rendering' stamp: 'pmm 2/1/2014 15:49'!
renderMaximumSizeOn: html
	html tableRow: [
		html tableHeading: [
			html label: 'Maximum Size' ].
		html tableData: [ 
			html textInput
			size: 5;
			on: #maximumSize of: self ] ].
	html tableRow: [
		html tableData
			colSpan: 2;
			with: 'Number of sessions supported. When this limit is reached the overflow action is run. 0 for no maximum size. Has to be positive.' ]! !

!WACacheNGAttributeEditor methodsFor: 'rendering' stamp: 'pmm 2/1/2014 15:51'!
renderOverflowActionOn: html
	html tableRow: [
		html tableHeading: [
			html label: 'Overflow Action' ].
		html tableData: [
			html select
				list: WAHashCacheNG overflowActions;
				labels: [ :each |
					overflowActionLabels at: each ifAbsent: [ each ] ];
				on: #overflowAction of: self ] ].
	html tableRow: [
		html tableData
			colSpan: 2;
			with: 'What to do when the maximum number of sessions is reached. Only matters when the maximum size is bigger than 0.' ]! !

!WACacheNGAttributeEditor methodsFor: 'actions' stamp: 'pmm 2/1/2014 14:36'!
replaceCache
	self
		confirm: 'This will clear all existing sessions in the current cache. Are you sure you want to continue?'
		onAnswer: [ :answer |
			answer ifTrue: [
				self handler cache: self createCache ] ]! !

WASystemConfiguration subclass: #WACacheNGConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Cache-NG'!

!WACacheNGConfiguration methodsFor: 'description' stamp: 'pmm 2/2/2014 19:25'!
describeOn: config
	(config integer: #maximumSize)
		comment: 'Number of sessions supported. When this limit is reached the overflow action is run. 0 for no maximum size. Has to be positive.';
		group: #cache;
		default: 10000.
	(config integer: #maximumRelativeAge)
		comment: 'After so many seconds of inactivity a session is considered expired. 0 for no limit. Has to be positive.';
		group: #cache;
		default: 1800. "30 min"
	(config integer: #maximumAbsoluteAge)
		comment: 'After so many seconds after its creation a session is considered expired no matter when it was last accessed. 0 for no limit. Has to be positive.';
		group: #cache;
		default: 28800. "8 h"
	(config list: #overflowAction)
		options: WAHashCacheNG overflowActions;
		comment: 'What to do when the maximum number of sessions is reached. Only matters when the maximum size is bigger than 0.';
		group: #cache;
		default: WAHashCacheNG removeRelativeOldest! !
WAHashTableSizes initialize!
